#ifndef HARDWARE_PROFILE_H
#define HARDWARE_PROFILE_H

#if defined(APP013_HobbyKit_18F46J50) || defined(APP013_HobbyKit_18F47J53)
	//#define USE_SELF_POWER_SENSE_IO
    #define tris_self_power		TRISCbits.TRISC2    // Input
    #define self_power			1

    //#define USE_USB_BUS_SENSE_IO
    #define tris_usb_bus_sense	TRISCbits.TRISC2    // Input
    #define USB_BUS_SENSE		1 

	#define CLOCK_FREQ			48000000L

	/** LED ************************************************************/
	#define mInitAllLEDs()		{					\
								LATE &= 0xFC;		\
								TRISE &= 0xFC;		\
								}							
	#define mLED_1				LATEbits.LATE0
	#define mLED_2				LATEbits.LATE1
	#define mLED_3
	#define mLED_4
			
	#define mGetLED_1()			mLED_1
	#define mGetLED_2()			mLED_2
	#define mGetLED_3()			1
	#define mGetLED_4()			1
			
	#define mLED_1_On()			mLED_1 = 1;
	#define mLED_2_On()			mLED_2 = 1;
	#define mLED_3_On()
	#define mLED_4_On()
			
	#define mLED_1_Off()		mLED_1 = 0;
	#define mLED_2_Off()		mLED_2 = 0;
	#define mLED_3_Off()
	#define mLED_4_Off()
	 
	#define mLED_1_Toggle()		mLED_1 = !mLED_1;
	#define mLED_2_Toggle()		mLED_2 = !mLED_2;
	#define mLED_3_Toggle()
	#define mLED_4_Toggle()     
	
	/** SWITCH *********************************************************/
	#define mInitSwitch2()      TRISBbits.TRISB2=1;
	#define mInitSwitch3()      mInitSwitch2();
	#define mInitAllSwitches()  mInitSwitch2();
	#define sw2                 PORTBbits.RB2
	#define sw3                 PORTBbits.RB2
	#define	sw					sw2
	
	/** I/O pin definitions ********************************************/
	#define INPUT_PIN 1
	#define OUTPUT_PIN 0

#elif defined(APP1618_SD_18F47J53) 
	//#define USE_SELF_POWER_SENSE_IO
    #define tris_self_power		TRISCbits.TRISC2    // Input
    #define self_power			1

    //#define USE_USB_BUS_SENSE_IO
    #define tris_usb_bus_sense	TRISCbits.TRISC2    // Input
    #define USB_BUS_SENSE		1 

	#define CLOCK_FREQ			48000000L

	/** LED ************************************************************/
	#define mInitAllLEDs()		{						\
								LATE &= 0xFC;			\
								TRISE &= 0xFC;			\
								ANCON0bits.PCFG5 = 1;	\
								ANCON0bits.PCFG6 = 1;	\
								}
	#define mLED_1				LATEbits.LATE0
	#define mLED_2				LATEbits.LATE1
	#define mLED_3
	#define mLED_4
			
	#define mGetLED_1()			mLED_1
	#define mGetLED_2()			mLED_2
	#define mGetLED_3()			1
	#define mGetLED_4()			1
			
	#define mLED_1_On()			mLED_1 = 0;
	#define mLED_2_On()			mLED_2 = 0;
	#define mLED_3_On()
	#define mLED_4_On()
			
	#define mLED_1_Off()		mLED_1 = 1;
	#define mLED_2_Off()		mLED_2 = 1;
	#define mLED_3_Off()
	#define mLED_4_Off()
	 
	#define mLED_1_Toggle()		mLED_1 = !mLED_1;
	#define mLED_2_Toggle()		mLED_2 = !mLED_2;
	#define mLED_3_Toggle()
	#define mLED_4_Toggle()     
	
	/** SWITCH *********************************************************/
    #define mInitSwitch2()      TRISBbits.TRISB0 = 1;
    #define mInitSwitch3()      TRISBbits.TRISB2 = 1;
    #define mInitAllSwitches()  mInitSwitch2(); mInitSwitch3()
    #define sw2                 PORTBbits.RB0
    #define sw3                 PORTBbits.RB2
	#define	sw					sw2
	
	/** I/O pin definitions ********************************************/
	#define INPUT_PIN 1
	#define OUTPUT_PIN 0

#else
    #error "Demo board not defined"
#endif

#endif  //HARDWARE_PROFILE_H
